Package org.apache.commons.collections4.trie

# Class PatriciaTrie<V>

java.lang.Object
java.util.AbstractMap<K,V>
org.apache.commons.collections4.trie.AbstractBitwiseTrie<K,V>
org.apache.commons.collections4.trie.AbstractPatriciaTrie<String,V>
org.apache.commons.collections4.trie.PatriciaTrie<V>

Type Parameters:
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Serializable`, `Map<String,V>`, `SortedMap<String,V>`, `Get<String,V>`, `IterableGet<String,V>`, `IterableMap<String,V>`, `IterableSortedMap<String,V>`, `OrderedMap<String,V>`, `Put<String,V>`, `Trie<String,V>`

public class PatriciaTrie<V> extends AbstractPatriciaTrie<String,V>
Implements a PATRICIA Trie (Practical Algorithm to Retrieve Information Coded in Alphanumeric).

A PATRICIA `Trie` is a compressed `Trie`. Instead of storing all data at the edges of the `Trie` (and having empty internal nodes), PATRICIA stores data in every node. This allows for very efficient traversal, insert, delete, predecessor, successor, prefix, range, and `AbstractPatriciaTrie.select(Object)` operations. All operations are performed at worst in O(K) time, where K is the number of bits in the largest item in the tree. In practice, operations actually take O(A(K)) time, where A(K) is the average number of bits of all items in the tree.

Most importantly, PATRICIA requires very few comparisons to keys while doing any operation. While performing a lookup, each comparison (at most K of them, described above) will perform a single bit comparison against the given key, instead of comparing the entire key to another key.

The `Trie` can return operations in lexicographical order using the 'prefixMap', 'submap', or 'iterator' methods. The `Trie` can also scan for items that are 'bitwise' (using an XOR metric) by the 'select' method. Bitwise closeness is determined by the `KeyAnalyzer` returning true or false for a bit being set or not in a given key.

This PATRICIA `Trie` supports both variable length & fixed length keys. Some methods, such as `Trie.prefixMap(Object)` are suited only to variable length keys.

Since:
  4.0
See Also:
  - Radix Tree
  - PATRICIA
  - Crit-Bit Tree
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.commons.collections4.trie.AbstractPatriciaTrie

  `AbstractPatriciaTrie.TrieEntry<K,V>`

  ## Nested classes/interfaces inherited from class java.util.AbstractMap

  `AbstractMap.SimpleEntry<K extends Object,V extends Object>, AbstractMap.SimpleImmutableEntry<K extends Object,V extends Object>`

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K extends Object,V extends Object>`

- ## Field Summary

  ### Fields inherited from class org.apache.commons.collections4.trie.AbstractPatriciaTrie

  `modCount`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PatriciaTrie()`
  `PatriciaTrie(Map<? extends String,? extends V> m)`

- ## Method Summary

  ### Methods inherited from class org.apache.commons.collections4.trie.AbstractPatriciaTrie

  `clear, comparator, containsKey, entrySet, firstKey, get, headMap, keySet, lastKey, mapIterator, nextKey, prefixMap, previousKey, put, remove, select, selectKey, selectValue, size, subMap, tailMap, values`

  ### Methods inherited from class org.apache.commons.collections4.trie.AbstractBitwiseTrie

  `getKeyAnalyzer, toString`

  ### Methods inherited from class java.util.AbstractMap

  `clone, containsValue, equals, hashCode, isEmpty, putAll`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.Get

  `containsValue, isEmpty`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, containsValue, equals, forEach, getOrDefault, hashCode, isEmpty, merge, putAll, putIfAbsent, remove, replace, replace, replaceAll`

  ### Methods inherited from interface org.apache.commons.collections4.Put

  `putAll`

- ## Constructor Details

  - ### PatriciaTrie

    public PatriciaTrie()

  - ### PatriciaTrie

    public PatriciaTrie(Map<? extends String,? extends V> m)